 num2str_endchar equ '$'   ;For DOS
;num2str_endchar equ 0     ;For our own functions


;NOTE: This function should be exported by the kernel...
;      It should also preserve FLAGS, not let them be left altered
;;

;/*
; Inputs:
;        BL  -- base to convert to
;        EAX -- binary value to convert to string
;        EDI -- end of intended string (since the string
;               is generated backwards)
;
; Outputs:
;        ECX -- lenght of string
;        EDI -- start of the generated string
;
;*/
;include_debugstr gioow4rg5jk4r5goik,"num2str"
num2str32:
 push wideax
 push widebx
 push widedx
 push widebp
 pushfwide


 and ebx,11111111b;
 xor ecx,ecx;

 ;BUG: This function cannot call itself
 ;     with this debug macro, or it will loop
 ;     until crashing.
 ;;
 ;printdbg_str_hexnum sadflAFERFkfdt34,"num2str widedi: ",0,widedi



 mov byte[widedi],num2str_endchar
 dec edi




 cmp wideax,0
 jnz .noeax0;
   inc ecx;
   mov byte[widedi],'0';
   jmp .end;
 .noeax0:


 .while_ln_534543:
 cmp wideax,0
 jz .while_ln_534543_end

  inc widecx;
  

  ;//Clear EDX for the 32-bit-only division
  ;//and perform the assembly division:
  ;;
   xor widedx,widedx;
       div widebx;   ;//EDX:EAX / EBX == EAX quotient
                  ;//                 EDX remainder


  ;//Take a copy of the remainder:
  ;;
   mov widebp,widedx;


  ;//Convert binary remainder to ASCII value:
  ;;
   cmp dl,0
   jb .try10
   cmp dl,9
   ja .try10;
    add dl,0x30;  ;// '0' to '9'
   jmp .endif


   .try10:
   cmp dl,10
   jb .endif
    add dl,(0x41-10);  ;// 'A' and beyond


   .endif:


  ;//Put the character in the string:
  ;;
   mov byte[widedi],dl;





  dec widedi;


 jmp .while_ln_534543;
 .while_ln_534543_end:



  inc widedi;





 .end:
 popfwide
 pop widebp
 pop widedx
 pop widebx
 pop wideax
retwide
